<?php
//####################################################################
// Active PHP Bookmarks - lbstone.com/apb/
//
// Filename: add_bookmark.php
// Author:   L. Brandon Stone (lbstone.com)
//           Nathanial P. Hendler (retards.org)
//
// 2001-09-05 03:35     Starting on version 1.0  The structure of
//                      this program is very similar to the original
//                      insert_bookmark section of apb (0.1.0 - 0.6.01)
// 2001-09-05 09:05     Appears to be working.
// 2004-02-21 [CAP]     Redid tags and layout so to be more friendly
//                      to different browsers and font sizes
//
// This is pretty straight forward.  If the user hasn't authenticated
// they can't do anything.  If $action is set to insert_bookmark, we
// need to insert a bookmark, which may involve created a new group.
// If $action isn't set, we display the form for them to add a new
// bookmark, prefilling the fields if we're passed $form_* values.
//
//####################################################################

include_once('apb.php');
apb_head();

//echo "[".$APB_SETTINGS['auth_user_id']."]";

if ($APB_SETTINGS['auth_user_id']) {

    // We have an authenticated user.
    $id = null;
    if (isset($_GET['id']))
    {
        $id = addslashes ($_GET['id']);
    }

// Javascript quickadd uses get to add bookmarks, so let's
// try to accommodate that
    if (isset($_GET['form_title']))
    {
        $form_title = addslashes ($_GET['form_title']);
    }
    if (isset($_GET['form_url']))
    {
        $form_url = addslashes ($_GET['form_url']);
    }
    print "<div class='editbox'>";
    print "<div class='editboxheader'>" . (($id) ? 'Edit' : 'Add') . " Bookmark</div><br>\n";

    $action = '';
    $form_private = null;
    $form_description = null;
    if (isset($_GET['action']))
    {
        $action = addslashes ($_GET['action']);
    }
    if (isset($_POST['form_url']))
    {
        $form_url = addslashes ($_POST['form_url']);
    }

    // If we're going to insert, we need to have a URL. [LBS 20020211]
    if ($action == 'insert_bookmark' && !empty ($form_url)) {

        $form_group_type = $_POST['form_group_type'];
        if (!empty ($_POST['form_group_title']))
        {
            $form_group_title = $_POST['form_group_title'];
        }

        // We're inserting a new bookmark.

        if ($form_group_type == 'new' && $form_group_title) {

            $form_group_parent_id = $_POST['form_group_parent_id'];

            // INSERT new group

            $query = "
                INSERT INTO apb_groups
                (group_parent_id, group_title, user_id, group_creation_date)
                VALUES
                ($form_group_parent_id, '$form_group_title', '".$APB_SETTINGS['auth_user_id']."', NOW())
            ";
            $result = mysql_db_query($APB_SETTINGS['apb_database'], $query);

            // Groups have to be unique accross group_title and
            // user_id, so we just do the previous insert blindly
            // and now query the db for the group_id of the group
            // which we'll use in our bookmark insert.  If the last
            // insert failed, it's because the group already
            // existed for that user_id, which doesn't prohibit us
            // from just going ahead and using the existing group
            // for the bookmark insert.

            $query = "
                SELECT group_id
                  FROM apb_groups
                 WHERE group_title = '$form_group_title'
                   AND user_id = '".$APB_SETTINGS['auth_user_id']."'
            ";

            $result = mysql_db_query($APB_SETTINGS['apb_database'], $query);
            $row = mysql_fetch_assoc($result);
            $form_group_id = $row['group_id'];

        }
        else
        {
            $form_group_id = $_POST['form_group_id'];
        }

        // INSERT or UPDATE bookmark

        if (isset($_POST['form_id']))
        {
            $form_id = $_POST['form_id'];
        }

        if (!empty ($form_id)) {


// Hacked this line, because I'm not sure it's needed... plus it helps
// me to display the bookmark link, if we haven't defined $b yet. [LBS]
//            if ($b->user_id == $APB_SETTINGS['auth_user_id']) {
            if (1) {
                if (isset($_GET['form_title']))
                {
                    $form_title = addslashes ($_GET['form_title']);
                }
                if (isset($_POST['form_title']))
                {
                    $form_title = addslashes ($_POST['form_title']);
                }
                $form_description = addslashes ($_POST['form_description']);
                $form_private = addslashes ($_POST['form_private']);
                $back_url = addslashes ($_POST['back_url']);
                $query = "
                    UPDATE apb_bookmarks
                       SET group_id = '$form_group_id',
                           bookmark_title = '$form_title',
                           bookmark_url = '$form_url',
                           bookmark_description = '$form_description',
                           bookmark_private = '$form_private'
                     WHERE bookmark_id = $form_id
                       AND user_id = '".$APB_SETTINGS['auth_user_id']."'
                     LIMIT 1
                ";
                #print "<p><pre>$query</pre><p>\n";
                $result = mysql_db_query($APB_SETTINGS['apb_database'], $query);
                if ($result) {

                    $b = apb_bookmark($form_id);
                    $g = apb_group($b->group_id());

                    ?>

                    <p>Bookmark saved!

                    <p><?php echo $g->print_group_path() ?>

                    <p><?php echo $b->link('link') ?>

                    <p><a href='<?php echo $back_url ?>'>Go Back to Editing</a>

                    <?php
                } else {
                    error("Bookmark edit failed!!");
                }
            } else {
                error("You don't have permission to edit this bookmark.");
            }

        } else {
            $form_title = addslashes ($_POST['form_title']);
            $form_description = addslashes ($_POST['form_description']);
            $form_private = addslashes ($_POST['form_private']);
            $query = "
                INSERT INTO apb_bookmarks
                    (group_id, bookmark_title, bookmark_url, bookmark_description,
                     bookmark_creation_date, bookmark_private, user_id)
                    VALUES
                    ($form_group_id, '$form_title', '$form_url', '$form_description',
                     NOW(), '$form_private', '".$APB_SETTINGS['auth_user_id']."')
            ";

            $result = mysql_db_query($APB_SETTINGS['apb_database'], $query);

            if ($result) {

                $b = apb_bookmark(mysql_insert_id());
                $g = apb_group($b->group_id());

                ?>

                <p>Bookmark saved!

                <p><?php echo $g->print_group_path() ?>

                <p><?php echo $b->link('link') ?>

                <?php

            } else {
                error("Bookmark add failed!!");
            }
        }

    } elseif ($action == 'delete_bookmark') {
        $bookmark_id = 0;
        if (isset($_GET['bookmark_id']))
        {
            $bookmark_id = $_GET['bookmark_id'];
        }
        $back_url = $_POST['back_url'];
        $b = apb_bookmark($bookmark_id);
        debug("I want to delete " . $b->link('link'), 1);
        if ($b->user_id() == $APB_SETTINGS['auth_user_id']) {
            debug("I have permission", 1);
            $query = "
                UPDATE apb_bookmarks
                   SET bookmark_deleted = '1'
                 WHERE bookmark_id = $bookmark_id
                 LIMIT 1
            ";
            debug($query, 3);
            $result = mysql_db_query($APB_SETTINGS['apb_database'], $query);
            print "Bookmark Deleted<br>\n";

            ?>

            <p><a href='<?php echo $back_url ?>'>Go Back to Editing</a>

            <?php

        } else {
            debug("I don't have permission", 1);
            print "Can't delete, you don't have permission<br>\n";
        }

    } else {

        set_magic_quotes_runtime(0); ?>

        <?php

        if ($id) {
            $b = apb_bookmark($id);
            $form_group_id = $b->group_id();
            $form_title = $b->title();
            $form_url = $b->url();
            $form_description = $b->description();
            $form_private = $b->apb_private();
            $id_owner_user_id = $b->user_id();
        }

        if (! $id || $id_owner_user_id == $APB_SETTINGS['auth_user_id']) {

            ?>
            <div>
            <form action="<?php echo $_SERVER['SCRIPT_NAME'] ?>?action=insert_bookmark" method="post">
            <input type='hidden' name='back_url' value='<?php echo $_SERVER['HTTP_REFERER'] ?>'>
            <?php if ($id) { print "<input type='hidden' name='form_id' value='$id'>\n"; } ?>

                <?php

                // If there are already groups, show the advanced group editor. [LBS 20020211]
                if (get_number_of_groups() > 0)
                {
                    ?>

                            <div class='editboxfields'>
                            <div class="editfieldlabel"><input type="radio" class="radio" name="form_group_type" value="existing" checked>
                            Existing Group:
                            </div>
                            <div class='editmenu'><?php groups_dropdown('form_group_id', (!empty ($form_group_id) ? $form_group_id : null)) ?>
                            </div>
                            </div>
                           <div style="clear:both"><br><hr></div>
                            <div class='editboxfields'>
                            <div class="editfieldlabel"><input type="radio" class="radio" name="form_group_type" value="new">
                            New Group:
                            </div>
                            <div>
                            <input class='text' name="form_group_title" value="<?php echo (!empty ($form_group_title) ? $form_group_title : '') ?>">
                            </div>
                            <div class="editfieldlabel">Parent Group:
                            </div>
                            <div class='editmenu'><?php groups_dropdown('form_group_parent_id', '0', '[top level]') ?>
                            </div>
                            </div>
                           <div style="clear:both"><br><hr></div>

                    <?php
                }
                // If there are not any groups yet, show the simple group editor. [LBS 20020211]
                else
                {
                    $form_group_title = null;
                    if (!empty ($form_group_title)) { $form_group_title = "My First Group"; }

                    ?>
                    <input type="hidden" name="form_group_type" value="new">
                    <input type="hidden" name="form_group_parent_id" value="0">
                            <div>New Group: <input name="form_group_title" class="text" size="20" value="<?php echo $form_group_title ?>"></div>

                    <?php
                }

                ?>

                        <div class='editboxfields'>
                        <div class="editfieldlabel">Title:
                        </div>
<?php 
    if (isset($_GET['form_title']))
    {
        $form_title = $_GET['form_title'];
    }
?>
                        <div><input class="text" name="form_title" value="<?php echo (!empty ($form_title) ? stripslashes($form_title) : '') ?>">
                        </div>
                        </div>

                        <div class='editboxfields'>
                        <div class="editfieldlabel">URL:
                        </div>
<?php 
    if (isset($_GET['form_url']))
    {
        $form_url = $_GET['form_url'];
    }
?>
                        <div><input class="text" name="form_url" value="<?php echo (!empty ($form_url) ? $form_url : null) ?>">
                        </div>
                        </div>

                        <div class='editboxfields'>
                        <div class="editfieldlabel">Description:
                        </div>
                        <div><input class="text" name="form_description" value="<?php echo (!empty ($form_description) ? stripslashes($form_description) : '') ?>">
                        </div>
                        </div>

                        <div class='editboxfields'>
                        <div class="editfieldlabel">Private:</div>
                            <div class='yesorno'>No <input type='radio' class='radio' name='form_private' value='0' <?php
                                echo (($form_private == '1') ? '' : ' CHECKED' ) ?> >
                            Yes <input type='radio' class='radio' name='form_private' value='1' <?php
                                echo (($form_private == '1') ? ' CHECKED' : '' ) ?> ></div></div></div><br>
            <div align="center"><input type="submit" value="<?php echo (($id) ? 'Edit' : 'Add') ?> Bookmark"></div>

            </form>

         <?php if ($id) { ?>
         <form action="<?php echo $_SERVER['SCRIPT_NAME'] ?>?action=delete_bookmark&bookmark_id=<?php echo $id ?>" method="post">
         <input type='hidden' name='back_url' value='<?php echo $_SERVER['HTTP_REFERER'] ?>'>
         <div align="center">
         <input type="submit" value="Delete Bookmark" onClick="return confirm('Are you sure you want to delete this bookmark?')"></div>
         </form>

         <?php } ?>

            <?php
        } else {
            error("You don't have permission to edit this bookmark");
        }

    }

} else {

    print "<p><b>You must be logged in to do whatever it is you wanted to do.</b>\n";
    echo  "<p>When you log in, you should select the 'Remember Me' option to avoid this in the future.\n\n";

}

print "</div>";
apb_foot();

?>
